﻿; ANI editor 0.3
; converted from alasm

	DEVICE ZXSPECTRUM128

LISTTAB EQU #9B00       ; (fram.nr,delay)
FRAMTAB EQU #9D00       ; (cluster)
FAT     EQU #9F00       ; FAT8 (64K)
FRAMBUF EQU #A000       ; кадр (столбцами с цветом): #2000
                        ; 256/column: 192 bytes, 24 color
SORTTAB EQU #A900

UNDOBUF EQU #E000       ; буфер для undo (#2000)

WrkPage EQU 0           ; рабочая (фон окон, ундо/буфер файла)
DatPag1 EQU 1           ; данные (кадры)
DatPag2 EQU 3
DatPag3 EQU 4
DatPag4 EQU 7
BufPage EQU 6           ; буфер (мусор, оверлеи)

        MACRO DBW bt,wr
        DB bt
        DW wr
        ENDM 

        MACRO LDB dst,src
        LD A,src
        LD dst,A
        ENDM 

        ORG #6000,0

        JP FUNC         ; #6000 - вызов функций
go_anie JP START1       ; #6003 - рестарт

XSIZE   DB 1            ; размеры кадра
YSIZE   DB 1
YSIZE8  DB 8
XPOS    DB 0            ; позиция окна просмотра
YPOS    DB 0
FRAMES  DB 0            ; всего кадров
CURFRAM DB 0            ; текущий кадр
CURPOS  DB 0            ; текущая позиция
LISTLEN DB 0            ; длина списка
COLOR   DB 7            ; текущий цвет

stack   LD SP,0
        CALL INIT

        LD IX,Butz_22
        CALL OUTBUTZ
        CALL AOX_ATR
        CALL COL_ATR
        CALL OUT_LMP
        CALL OUTMODE
        CALL INITARR
        CALL NOMOVE
        LD HL,Butz_22
        LD DE,MainKey
        LD BC,SHOWBOX
        OR 2
        JP TESTBUT

TO_ATR  RRA 
        RRA 
        RRA 
        AND 3
        OR #58
        RET 

SETPAGE LD A,WrkPage
        JR BANK
BUFPAGE LD A,BufPage
        JR BANK
WRKBANK LD A,WrkPage
        JR BANK
DATPAGE PUSH BC
        AND 3
        LD BC,DatPage
        ADD A,C
        LD C,A
        ADC A,B
        SUB C
        LD B,A
        LD A,(BC)
        POP BC
BANK    PUSH BC
        AND 7
        OR #10
        LD BC,#7FFD
        OUT (C),A
        POP BC
        RET 

DatPage DB DatPag1,DatPag2,DatPag3,DatPag4

INIT    LD HL,LISTTAB
        LD DE,LISTTAB+1
        LD BC,#BFFF-LISTTAB
        XOR A
        LD (HL),A
        LDIR 
        LD (FRAMES),A
        LD (LISTLEN),A
        LD (CURFRAM),A
        LD (CURPOS),A
        LD (XWin),A
        LD (YWin),A
        JP SET_WPA

EDIT_D  LD A,(YSIZE)
        SUB 5
        RET Z
        CCF 
        RET NC
        DEC A
        LD HL,YPOS
        JR edir_1
EDIT_R  LD A,(XSIZE)
        SUB 5
        RET Z
        CCF 
        RET NC
        DEC A
        LD HL,XPOS
edir_1  CP (HL)
        CCF 
        RET NC
        INC (HL)
        JR edil_1
EDIT_U  LD A,(YPOS)
        AND A
        RET Z
        DEC A
        LD (YPOS),A
        JR edil_1
EDIT_L  LD A,(XPOS)
        AND A
        RET Z
        DEC A
        LD (XPOS),A
edil_1  CALL CASHARR
        CALL OUT_ALL
        CALL INITARR
        CALL NOMOVE
        AND A
        RET 

SET_XOR LD A,0
        JR SET_AOX
SET_OR  LD A,1
        JR SET_AOX
SET_AND LD A,2
SET_AOX LD (EdiType),A
        CALL NC,PUSHPOP
AOX_ATR LD HL,#5936
        LD DE,31
        LD A,(EdiType)
        LD B,3
        LD C,A
aoxa_1  LD A,3
        SUB B
        CP C
        LD A,7
        JR Z,aoxa_2
        LD A,4
aoxa_2  CALL PODSWET
        ADD HL,DE
        DJNZ aoxa_1
        RET 

COL_ATR LD HL,#5938
repods  LD DE,31
        LD A,(COLOR)
PODSWET LD (HL),A
        INC L
        LD (HL),A
        ADD HL,DE
        LD (HL),A
        INC L
        LD (HL),A
        RET 
;---------------------------
COPY_F  CALL NC,PUSHPOP
        CALL CASHARR
        CALL BUFPAGE
        LD HL,FRAMBUF
        LD DE,#C000
        LD BC,#2000
        LDIR 
        LD HL,ShowBox
        SET 2,(HL)
        CALL NOKEY
RET_ARR CALL NOFIRE
        CALL NOMOVE
        CALL INITARR
        CALL WRKBANK
        AND A
        RET 
;---------------------------
SEL_COL
        CALL NC,PUSHPOP
        CALL CASHARR
        CALL WRKBANK
        LD DE,#FFFF
        LD BC,#0615
        AND A
        CALL WINDOW
        LD IX,ColButz
        CALL OUTBUTZ

        LD DE,#0101
        CALL OTKOLZ
        LD DE,#0102
        CALL OTKOLZ
        LD DE,#0103
        CALL OTKOLZ
        LD DE,#0104
        CALL OTKOLZ
        CALL SAMPLC

        CALL INITARR

        LD HL,ColButz
        LD DE,ColKeyz
        XOR A
        SCF 
        CALL TESTBUT

        CALL CASHARR
        CALL RESTFON
        CALL COL_ATR
        CALL NOKEY
        JP RET_ARR

ColButz DB 1,1,2,2,35
        DW INK_0
        DB 3,1,2,2,36
        DW INK_1
        DB 5,1,2,2,36
        DW INK_2
        DB 7,1,2,2,36
        DW INK_3
        DB 9,1,2,2,36
        DW INK_4
        DB 11,1,2,2,36
        DW INK_5
        DB 13,1,2,2,36
        DW INK_6
        DB 15,1,2,2,36
        DW INK_7

        DB 1,3,2,2,35
        DW PAP_0
        DB 3,3,2,2,36
        DW PAP_1
        DB 5,3,2,2,36
        DW PAP_2
        DB 7,3,2,2,36
        DW PAP_3
        DB 9,3,2,2,36
        DW PAP_4
        DB 11,3,2,2,36
        DW PAP_5
        DB 13,3,2,2,36
        DW PAP_6
        DB 15,3,2,2,36
        DW PAP_7

        DB 18,1,2,2,34
        DW skip
BRI     DB 18,3,2,2,0
        DW CHA_BRI

        DB 0,0,21,6,255 ; window
        DW skip
        DB 0,0,255,255,255 ; all other
        DW 0
        DB 255
ColKeyz
        DB 255

CHA_BRI CALL PUSHPOP
        LD A,(BRI+4)
        XOR 19
        LD (BRI+4),A
        LD A,(COLOR)
        XOR #40
        LD (COLOR),A
        CALL CASHARR
        LD IX,BRI
        CALL OUTBUTZ
        CALL INITARR
        CALL NOMOVE
        JR SAMPLC

INK_0   LD C,#00
        JR chInk
INK_1   LD C,#01
        JR chInk
INK_2   LD C,#02
        JR chInk
INK_3   LD C,#03
        JR chInk
INK_4   LD C,#04
        JR chInk
INK_5   LD C,#05
        JR chInk
INK_6   LD C,#06
        JR chInk
INK_7   LD C,#07
chInk	ld b,0xf8
        JR CHA_COL
PAP_0   LD C,#00
        JR chPap
PAP_1   LD C,#08
        JR chPap
PAP_2   LD C,#10
        JR chPap
PAP_3   LD C,#18
        JR chPap
PAP_4   LD C,#20
        JR chPap
PAP_5   LD C,#28
        JR chPap
PAP_6   LD C,#30
        JR chPap
PAP_7   LD C,#38
chPap	ld b,0xc7
CHA_COL LD A,(COLOR)
        AND B
        OR C
        LD (COLOR),A
SAMPLC  LD DE,#1201
        CALL INWINAT
        EX DE,HL
        CALL repods
        AND A
        RET 

OTKOLZ  CALL INWINAT
        LD HL,ColAtrz
        LD BC,16
        LDIR 
        RET 

INWINAT LD A,(XWin)
        ADD A,D
        LD D,A
        LD A,(YWin)
        ADD A,E
        LD E,A
        RRCA 
        RRCA 
        RRCA 
        AND #E0
        OR D
        LD L,A
        LD A,E
        CALL TO_ATR
        LD D,A
        LD E,L
        RET 

ColAtrz DB 7,7,1,1,2,2,3,3,4,4,5,5,6,6,7,7
;---------------------------
TESTBUT
        LD A,#C0        ; in: SCF=0 нет контроля RMB
        JR C,tbut_I1    ;       Z=0 нет доп.контроля
        LD A,0          ;       Z=1 в BC - адрес доп.проги
tbut_I1 LD (RMB_ex),A
        JR NZ,tbut_I2
        LD BC,skip
tbut_I2 LD (tbut_1A+1),BC
        LD (ButtAdr),HL ; HL : таблица кнопок
        LD (KeyAddr),DE ; DE : таблица клавиш
tbut_1  LD IX,(KeyAddr)
        XOR A
        LD (CS_flag),A
        LD (SS_flag),A
tbut_1Z LD A,(IX)
        CP #FF
        JR Z,tbut_1A
        CP 3
        JR NC,tbut_Z1
        LD C,A
        RR C
        SBC A,A
        AND #2F
        LD (CS_flag),A
        RR C
        SBC A,A
        AND #2F
        LD (SS_flag),A
        INC IX
        JR tbut_1Z
tbut_Z1 IN A,(#FE)
        AND (IX+1)
        JR NZ,tbut_1X
        LD A,#FE
        IN A,(254)
CS_flag NOP 
        RRA 
        JR NC,tbut_1X
        LD A,#7F
        IN A,(254)
SS_flag NOP 
        RRA 
        RRA 
        JR NC,tbut_1X
        LD L,(IX+2)
        LD H,(IX+3)
        LD A,H
        OR L
        RET Z
        SCF 
        CALL TB_CALL
        RET C
        JR tbut_1A

tbut_1X INC IX
        INC IX
        INC IX
        INC IX
        JR tbut_1Z
tbut_1A CALL skip
        CALL TESTARR
        JP NC,tbut_1
        LD A,C
        AND #40
        SCF 
RMB_ex  RET NZ
        CALL ARR_INW
        LD IX,(ButtAdr)
tbut_2  LD A,(IX)
        INC A
        JP Z,tbut_1
        LD A,D
        SUB (IX)
        CP (IX+2)
        JR NC,tbut_3
        LD A,E
        SUB (IX+1)
        CP (IX+3)
        JR NC,tbut_3
;       CALL PUSHPOP
        LD L,(IX+5)
        LD H,(IX+6)
        LD A,H
        OR L
        RET Z
        CALL TB_CALL
        RET C
        JP tbut_1
tbut_3  LD BC,7
        ADD IX,BC
        JR tbut_2

ARR_INW LD A,(ARROWX)   ; D=X E=Y стрелки в окне (по зн.местам)
sub_AX  SUB 0
        RRA 
        RRA 
        RRA 
        AND 31
        LD D,A
        LD A,(ARROWX+1)
sub_AY  SUB 0
        RRA 
        RRA 
        RRA 
        AND 31
        LD E,A
        RET 

TB_CALL PUSH HL
        LD HL,(tbut_1A+1)
        EX (SP),HL
        LD BC,(ButtAdr)
        LD DE,(KeyAddr)
        LD A,(RMB_ex)
        PUSH AF
        PUSH BC
        PUSH DE
        CALL CALL_HL
        EXA 
        POP DE
        POP BC
        POP AF
        POP HL
        LD (RMB_ex),A
        LD (KeyAddr),DE
        LD (ButtAdr),BC
        LD (tbut_1A+1),HL
        EXA 
        RET 

PUSHPOP CALL CASHARR
        CALL BUTADR
        PUSH HL
        PUSH BC
        CALL PUSHER
        CALL INITARR
        CALL NOFIRE
        CALL CASHARR
        POP BC
        POP HL
        CALL POPER
        CALL INITARR
        JP NOMOVE

POPER   LD D,H
        LD E,L
        INC H
        LD A,B
        ADD A,A
        ADD A,A
        ADD A,A
        DEC A
        LD B,A
popu_1  PUSH BC
        PUSH HL
        PUSH DE
popu_2  LD A,(HL)
        LD (DE),A
        INC E
        INC L
        DEC C
        JR NZ,popu_2
        POP HL
        CALL NEXT_HL
        EX DE,HL
        POP HL
        CALL NEXT_HL
        POP BC
        DJNZ popu_1
        JR pupo_E

PUSHER  LD D,B
pupo_1  LD A,L
        ADD A,32
        LD L,A
        JR NC,pupo_2
        LD A,H
        ADD A,8
        LD H,A
pupo_2  DEC D
        JR NZ,pupo_1
        CALL PREV_HL
        LD D,H
        LD E,L
        DEC H
        LD A,B
        ADD A,A
        ADD A,A
        ADD A,A
        DEC A
        LD B,A
pupo_3  PUSH BC
        PUSH HL
        PUSH DE
pupo_4  LD A,(HL)
        LD (DE),A
        INC L
        INC E
        DEC C
        JR NZ,pupo_4
        POP HL
        CALL PREV_HL
        EX DE,HL
        POP HL
        CALL PREV_HL
        POP BC
        DJNZ pupo_3
pupo_E  XOR A
pupo_5  LD (DE),A
        INC E
        DEC C
        JR NZ,pupo_5
        RET 

OUTBUTZ LD HL,0
PUTBUTZ LD A,H
        OR L
        JR NZ,pbut_1
        LD HL,buttonz
pbut_1  LD (butaddr+1),HL
pbut_2  LD A,(IX)
        INC A
        RET Z
        CALL BUTADR
        LD A,(IX+4)
        CP 255
        CALL NZ,DRAWBUT
        LD DE,7
        ADD IX,DE
        JR pbut_2

BUTADR  LD A,(IX+1)
bad_AY1 ADD A,0
        RRCA 
        RRCA 
        RRCA 
        AND #E0
        OR (IX)
bad_AX1 ADD A,0
        LD L,A
        LD A,(IX+1)
bad_AY2 ADD A,0
        AND #18
        OR #40
        LD H,A
        LD B,(IX+3)
        LD C,(IX+2)
        RET 

DRAWBUT PUSH HL
butaddr LD HL,buttonz
        LD DE,36
        CALL ADDING
        POP DE
        PUSH DE
        PUSH BC
dbut_1  PUSH BC
        PUSH DE
dbut_2  LD A,(HL)
        LD (DE),A
        INC HL
        INC E
        DEC C
        JR NZ,dbut_2
        POP DE
        POP BC
        INC D
        LD A,D
        AND 7
        JR NZ,dbut_1
        LD A,E
        ADD A,32
        LD E,A
        JR C,dbut_3
        LD A,D
        SUB 8
        LD D,A
dbut_3  DJNZ dbut_1
        POP BC
        POP DE
        LD A,D
        CALL TO_ATR
        LD D,A
dbut_4  PUSH BC
        PUSH DE
dbut_5  LD A,(HL)
        LD (DE),A
        INC HL
        INC E
        DEC C
        JR NZ,dbut_5
        POP DE
        POP BC
        LD A,E
        ADD A,32
        LD E,A
        ADC A,D
        SUB E
        LD D,A
        DJNZ dbut_4
skip    RET 

OUTSKIN JP rzd_osk

CLS     LD HL,#4000
        LD DE,#4001
        LD BC,#1800
        LD (HL),L
        LDIR 
        LD BC,767
        LD (HL),7
        LDIR 
        XOR A
        OUT (254),A
        RET 

ADDING  INC A
add_1   DEC A
        RET Z
        ADD HL,DE
        JR add_1

NEXT_HL INC H
        LD A,H
        AND 7
        RET NZ
        LD A,L
        ADD A,32
        LD L,A
        RET C
        LD A,H
        SUB 8
        LD H,A
        RET 

PREV_HL LD A,H
        DEC H
        AND 7
        RET NZ
        LD A,L
        SUB 32
        LD L,A
        RET C
        LD A,H
        ADD A,8
        LD H,A
        RET 

NOFIRE  CALL INPUTJ
        LD A,C
        AND #F0
        JR NZ,NOFIRE
        JP NOMOVE

CALL_HL JP (HL)
CALL_DE PUSH DE
        RET 
;------------------------
SAVEFON
        CALL WRKBANK
        CALL SFON_RE
        JP SETPAGE

RESTFON CALL WRKBANK
        CALL RFON_RE
        JP SETPAGE

;------------------------
NOKEY   XOR A
        IN A,(254)
        CPL 
        AND 31
        JR NZ,NOKEY
        RET 

SET_WPA LD A,(YWin)
        LD (bad_AY1+1),A
        LD (bad_AY2+1),A
        ADD A,A
        ADD A,A
        ADD A,A
        LD (sub_AY+1),A
        LD A,(XWin)
        LD (bad_AX1+1),A
        ADD A,A
        ADD A,A
        ADD A,A
        LD (sub_AX+1),A
        RET 
;------------------------
WINDOW  PUSH AF
        CALL WRKBANK
        POP AF
        CALL WIND_RE
        JP SETPAGE

WIN_ARR LD A,(ARROWX)
        RRA 
        RRA 
        RRA 
        AND 31
        LD D,A
        LD A,(ARROWX+1)
        RRA 
        RRA 
        RRA 
        AND 31
        LD E,A
        ADD A,B
        SUB 24
        JR C,warr_1
        NEG 
        ADD A,E
        LD E,A
warr_1  LD A,D
        ADD A,C
        SUB 32
        RET C
        NEG 
        ADD A,D
        LD D,A
        RET 

ATRLINE CALL INWINAT
        EX DE,HL
atrl_1  LD (HL),C
        INC L
        DJNZ atrl_1
        RET 
;------------------------
PRINTS  LD A,32
PRINT   PUSH BC
        PUSH DE
        PUSH HL
        LD L,A
        LD H,0
        LD DE,Font
        ADD HL,DE
PrnPos  LD DE,0
        LD A,(XWin)
        ADD A,D
        LD D,A
        LD A,(YWin)
        ADD A,E
        LD E,A
        RRCA 
        RRCA 
        RRCA 
        AND #E0
        OR D
        LD B,A
        LD A,E
        AND #18
        OR #40
        LD D,A
        LD E,B
        LD B,8
pri_1   LD A,(HL)
        LD (DE),A
        INC H
        INC D
        DJNZ pri_1
        LD HL,PrnPos+2
        INC (HL)
        POP HL
        POP DE
        POP BC
        RET 

Font    INCBIN "finfont.bin"
;------------------------
MENFRAM LD HL,FramDes
        JR MEN_ALL
MENTRSH LD HL,TrshDes
        JR MEN_ALL
MENFILE LD HL,FileDes
MEN_ALL PUSH HL
        CALL PUSHPOP
        POP IX
        CALL CASHARR
        LD C,(IX+1)
        LD B,(IX+2)
        LD E,(IX+3)
        LD D,(IX+4)
        SCF 
        CALL WINDOW
        LD L,(IX+5)
        LD H,(IX+6)
        LD E,(IX+7)
        LD D,(IX+8)
        PUSH DE
        PUSH HL
        PUSH HL
        POP IX
        CALL OUTBUTZ
        CALL INITARR
        CALL NOMOVE
        POP HL
        POP DE
        XOR A
        CALL TESTBUT
        CALL CASHARR
        CALL RESTFON
        JP RET_ARR

FileDes DB 0
        DW #0602,#0102
        DW Butz_FL,FileKey
TrshDes DB 1
        DW #0402,#0302
        DW Butz_TR,TrshKey
FramDes DB 3
        DW #0606,#0502
        DW Butz_FR,FramKey

Butz_FL DB 0,0,2,2,1     ; FileMen
        DW NEWFILE
        DB 0,2,2,2,2
        DW LOADANI
        DB 0,4,2,2,3
        DW SAVEANI
        DB 0,0,255,255,255
        DW 0
        DB 255
FileKey
        DB 255

Butz_TR DB 0,0,2,2,14    ; RecycleMen
        DW SAVEBIN
        DB 0,2,2,2,15
        DW UNDO_M
        DB 0,0,255,255,255
        DW 0
        DB 255
TrshKey
        DB 255

Butz_FR DB 2,0,2,2,23    ; FrameWorkMen
        DW ADDFRAM
        DB 0,2,2,2,13
        DW CLEAR
        DB 2,2,2,2,24
        DW ADDCOPY
        DB 4,2,2,2,12
        DW INVERSE
        DB 2,4,2,2,22
        DW DELETE
        DB 0,0,255,255,255
        DW 0
        DB 255
FramKey
        DB 255
;-------------------
SAVEBIN
        CALL NC,PUSHPOP
        LD A,(FRAMES)
        AND A
        RET Z
savebin CALL WRKBANK
        LD HL,FRAMBUF
        LD DE,UNDOBUF
        LD BC,#2000
        LDIR 
        AND A
        RET 

UNDO_M
        CALL NC,PUSHPOP
        LD A,(FRAMES)
        AND A
        RET Z
        CALL WRKBANK
        LD HL,(TrshDes+1)
        CALL RESTFON
        CALL UNDO
        RET Z
        CALL CASHARR
        LD BC,(TrshDes+3)
        LD DE,(TrshDes+5)
        SCF 
        CALL WINDOW
        CALL INITARR
        CALL NOMOVE
        SCF 
        RET 

UNDO    LD A,(FRAMES)
        AND A
        RET Z
        CALL WRKBANK
        LD DE,UNDOBUF
        CALL SWAP_FR
        CALL CASHARR
        CALL OUT_ALL
        CALL NOKEY
        CALL INITARR
        CALL NOMOVE
        OR 2
        RET 

SWAP_FR LD HL,FRAMBUF
        LD BC,#2000
swap_1  LD A,(DE)
        EXA 
        LD A,(HL)
        LD (DE),A
        EXA 
        LD (HL),A
        INC HL
        INC DE
        DEC C
        JR NZ,swap_1
        DJNZ swap_1
        RET 
;-------------------
NEWFILE
        CALL PUSHPOP     ; Create a new file
        CALL CASHARR
        LD DE,#FFFF
        LD BC,#0410
        AND A
        CALL WINDOW
        LD DE,#0701
        LD BC,#0504
        CALL ATRLINE
        LD DE,#0702
        LD BC,#0504
        CALL ATRLINE
        LD A,1
        LD (XNEW),A
        LD (YNEW),A
        CALL OUT_NXY

        LD IX,ButzNew
        CALL OUTBUTZ
        CALL INITARR
        CALL NOMOVE
        LD HL,ButzNew
        LD DE,KeysNew
        XOR A
        CALL TESTBUT
        JR NC,new_EX

        CALL INIT
        LD HL,(XNEW)
        LD (XSIZE),HL
        LD A,H
        ADD A,A
        ADD A,A
        ADD A,A
        LD (YSIZE8),A
        LD HL,0
        LD (XPOS),HL
        CALL CLSFRAM
        CALL PACKNEW
        LD HL,LISTTAB
        LD (HL),0
        INC H
        LD (HL),5
        LD A,1
        LD (LISTLEN),A
        CALL SAVEBIN
        CALL WRKBANK
        CALL new_EX
        CALL CASHARR
        CALL RESTFON
        CALL BAR_PAR
        CALL CLR_ALL
        CALL OUT_ALL

ReFile  LD DE,(FileDes+1)
        LD BC,(FileDes+3)
        SCF 
        CALL WINDOW
        CALL INITARR
        CALL NOMOVE
        SCF 
        RET 

new_EX  CALL CASHARR
        CALL RESTFON
        JP RET_ARR

BAR_PAR LD A,(YSIZE)
        CALL GETSTEP
        LD BC,BY_TAB
        LD A,24
        CALL MAK_BXY
        LD A,(XSIZE)
        CALL GETSTEP
        LD BC,BX_TAB
        LD A,32
MAK_BXY LD HL,0
mbxy_1  EXA 
        LD A,H
        LD (BC),A
        INC BC
        ADD HL,DE
        EXA 
        DEC A
        JR NZ,mbxy_1
        RET 

GETSTEP LD C,A
        LD B,0
        LD HL,#9E00
        LD DE,#FFFF
        AND A
gste_1  INC DE
        SBC HL,BC
        JR NC,gste_1
        LD A,E
        RET 

OnxyTxt DB 1,4,1
        DB "dX: "
        DBW 2,XNEW
        DB 1,4,2
        DB "dY: "
        DBW 2,YNEW
        DB 0

ButzNew DB 12,1,1,1,31          ; X+
        DW NEW_XI
        DB 13,1,1,1,32          ; X-
        DW NEW_XD
        DB 12,2,1,1,31          ; Y+
        DW NEW_YI
        DB 13,2,1,1,32          ; Y-
        DW NEW_YD
        DB 1,1,2,2,33           ; OK
        DW EXIT_CY
        DB 0,0,16,4,255         ; окно
        DW skip
        DB 0,0,255,255,255
        DW 0
        DB 255
KeysNew
        DB 255

EXIT_CY CALL PUSHPOP
        SCF 
        RET 

NEW_XD  CALL PUSHPOP
        LD A,(XNEW)
        DEC A
        JR Z,nxi_E
        JR nxi_Y
NEW_XI  CALL PUSHPOP
        LD A,(XNEW)
        CP 32
        JR NC,nxi_E
        INC A
nxi_Y   LD (XNEW),A
nxi_Z   CALL OUT_NXY
nxi_E   CALL NOFIRE
        CALL NOMOVE
        AND A
        RET 
NEW_YD  CALL PUSHPOP
        LD A,(YNEW)
        DEC A
        JR Z,nxi_E
        JR nxy_Y
NEW_YI  CALL PUSHPOP
        LD A,(YNEW)
        CP 24
        JR NC,nxi_E
        INC A
nxy_Y   LD (YNEW),A
        JR nxi_Z
;----------------------

OUT_NXY LD HL,OnxyTxt
TEXT    LD A,(HL)
        AND A
        RET Z
        INC HL
        CP 4
        JR C,txt_C
        CALL PRINT
        JR TEXT
txt_C   PUSH HL
        LD HL,TCTab
        ADD A,A
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD E,(HL)
        INC HL
        LD D,(HL)
        POP HL
        CALL CALL_DE
        JR TEXT

TCTab   DW skip,TC_POS,TC_NUM,skip

TC_POS  LD D,(HL)
        INC HL
        LD E,(HL)
        INC HL
        LD (PrnPos+1),DE
        RET 

TC_NUM  LD E,(HL)
        INC HL
        LD D,(HL)
        INC HL
        LD A,(DE)
PRN_NUM LD DE,#6400
        CALL RAZR
        LD D,10
        CALL RAZR
        ADD A,"0"
        JP PRINT
RAZR    LD C,"0"-1
rzr_1   INC C
        SUB D
        JR NC,rzr_1
        ADD A,D
        PUSH AF
        LD A,E
        AND A
        LD A,C
        JR NZ,rzr_L
        CP "0"
        LD E,1
        JR NZ,rzr_L
        LD E,0
        LD A,32
rzr_L   CALL PRINT
        POP AF
        RET 

;------------------------

OUT_ALL
        CALL OUTEDIT
        CALL OUTVIEW
outa_IN CALL OUTYBAR
        CALL OUTXBAR
        CALL OUTFNUM
        CALL OUTPNUM
        RET 

OUTPNUM LD HL,#1B0A
        LD A,(CURPOS)
        CALL opnu_1
        LD A,(CURPOS)
        LD L,A
        LD H,high LISTTAB + 1
        LD A,(HL)
        LD HL,#1B0E
opnu_1  LD (PrnPos+1),HL
        LD C,A
        LD A,(FRAMES)
        AND A
        JR Z,TriSPC
        LD A,(LISTTAB+256)
        AND A
        JR Z,TriSPC
        LD A,(EdiMode)
        AND A
        JR Z,TriSPC
        LD A,C
        JP PRN_NUM

OUTFNUM LD HL,#1B0C
        LD (PrnPos+1),HL
        LD A,(FRAMES)
        AND A
        LD A,(CURFRAM)
        JP NZ,PRN_NUM
TriSPC  CALL PRINTS
        CALL PRINTS
        JP PRINTS

OUT_ATR LD A,(XPOS)
        ADD A,high FRAMBUF
        LD D,A
        LD A,(YPOS)
        ADD A,#C0
        LD E,A
        LD HL,#5861
        LD B,5
oatr_1  LD A,4
oatr_2  EXA 
        LD C,5
        PUSH DE
oatr_3  LD A,(DE)
        LD (HL),A
        INC L
        LD (HL),A
        INC L
        LD (HL),A
        INC L
        LD (HL),A
        INC L
        INC D
        DEC C
        JR NZ,oatr_3
        POP DE
        LD A,L
        ADD A,12
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        EXA 
        DEC A
        JR NZ,oatr_2
        INC E
        DJNZ oatr_1
        RET 
OUTYBAR
        LD HL,#4160
        LD A,(FRAMES)
        AND A
        JR Z,BY_emp
        LD A,(YPOS)
        CALL GETF_BY
        LD (BYLen1+1),A
        AND A
        LD B,A
        LD C,#C6
        CALL NZ,BY_FILL
        LD A,(YSIZE)
        CP 5
        JR C,oyb_1
        LD A,5
oyb_1   CALL GETF_BY
        LD B,A
BYLen1  ADD A,0
        LD (BYLen2+1),A
        LD C,#BA
        CALL BY_FILL
        LD A,159
BYLen2  SUB 0
        RET C
        RET Z
        LD B,A
        LD C,#C6
        JR BY_FILL
BY_emp  LD BC,#9EC6
BY_FILL LD (HL),C
        CALL NEXT_HL
        DJNZ BY_FILL
        RET 

GETF_BX LD BC,BX_TAB
        JR getby_1
GETF_BY LD BC,BY_TAB
getby_1 ADD A,C
        LD C,A
        ADC A,B
        SUB C
        LD B,A
        LD A,(BC)
        RET 

OUTXBAR
        CALL GETXLIN
        LD DE,#54E1
        CALL DROP_XL
        LD DE,#55E1
        CALL DROP_XL
        LD DE,#52E1
        CALL DROP_XI
        LD DE,#56E1
DROP_XI LD B,20
        LD HL,#53E1
drxi_1  LD A,(HL)
        CPL 
        LD (DE),A
        INC L
        INC E
        DJNZ drxi_1
        RET 
DROP_XL LD HL,#53E1
        LD BC,20
        LDIR 
        RET 
GETXLIN LD HL,#53E1
        LD E,#80
        LD A,(FRAMES)
        AND A
        LD B,160
        JR Z,BX_RES
        LD A,(XPOS)
        CALL GETF_BX
        LD (BXLen1+1),A
        AND A
        LD B,A
        CALL NZ,BX_RES
        LD A,(XSIZE)
        CP 5
        JR C,gxlin_1
        LD A,5
gxlin_1 CALL GETF_BX
        LD B,A
BXLen1  ADD A,0
        LD (BXLen2+1),A
        CALL BX_SET
        LD A,160
BXLen2  SUB 0
        RET C
        RET Z
        LD B,A
BX_RES  LD A,E
        CPL 
        AND (HL)
        LD (HL),A
        RRC E
        JR NC,bxr_1
        INC L
bxr_1   DJNZ BX_RES
        RET 
BX_SET  LD A,(HL)
        OR E
        LD (HL),A
        RRC E
        JR NC,bxs_1
        INC L
bxs_1   DJNZ BX_SET
        RET 

OUTVIEW CALL GETOPAR
        EXX 
        LD DE,#5876
        EXX 
        LD DE,#4076
ovew_1  PUSH BC
        PUSH DE
        PUSH HL
ovew_2  LD A,(HL)
        LD (DE),A
        INC L
        INC D
        LD A,D
        AND 7
        JR NZ,ovew_3
        LD A,E
        ADD A,32
        LD E,A
        JR C,ovew_3
        LD A,D
        SUB 8
        LD D,A
ovew_3  DEC C
        JR NZ,ovew_2
        POP HL
        POP DE
        POP BC
        INC H
        INC E
        PUSH BC
        EXX 
        POP BC
        PUSH DE
        PUSH HL
ovew_4  LD A,(HL)
        LD (DE),A
        INC L
        LD A,E
        ADD A,32
        LD E,A
        ADC A,D
        SUB E
        LD D,A
        LD A,C
        SUB 8
        LD C,A
        JR NZ,ovew_4
        POP HL
        POP DE
        INC H
        INC E
        EXX 
        DJNZ ovew_1
        RET 

OUTEDIT CALL sbox_N
        CALL CASHARR
        CALL GETOPAR
        EXX 
        LD DE,#5861
        EXX 
        LD DE,#4061
oed_1   PUSH DE
        PUSH BC
        PUSH HL
oed_2   LD A,(HL)
        CALL OUTBYTE
        INC L
        INC D
        INC D
        INC D
        INC D
        LD A,D
        AND 7
        JR NZ,oed_3
        LD A,E
        ADD A,32
        LD E,A
        JR C,oed_3
        LD A,D
        SUB 8
        LD D,A
oed_3   DEC C
        JR NZ,oed_2
        POP HL
        POP BC
        POP DE
        PUSH BC
        EXX 
        POP BC
        PUSH DE
        PUSH HL
oed_4   LD B,4
oed_5   LD A,(HL)
        LD (DE),A
        INC E
        LD (DE),A
        INC E
        LD (DE),A
        INC E
        LD (DE),A
        LD A,E
        ADD A,29
        LD E,A
        ADC A,D
        SUB E
        LD D,A
        DJNZ oed_5
        INC L
        LD A,C
        SUB 8
        LD C,A
        JR NZ,oed_4
        POP HL
        POP DE
        INC H
        INC E
        INC E
        INC E
        INC E
        EXX 
        INC E
        INC E
        INC E
        INC E
        INC H
        DJNZ oed_1
        RET 

OUTBYTE PUSH HL
        PUSH DE
        PUSH BC
        LD C,A
        CALL OUTPAIR
        CALL OUTPAIR
        CALL OUTPAIR
        CALL OUTPAIR
        POP BC
        POP DE
        POP HL
        RET 

OUTPAIR RLC C
        RLC C
        LD A,C
        AND 3
        ADD A,A
        ADD A,A
        LD HL,PairZ
        ADD A,L
        LD L,A
        ADC A,H
        SUB L
        LD H,A
        LD A,(HL)
        LD (DE),A
        INC D
        INC HL
        LD A,(HL)
        LD (DE),A
        INC D
        INC HL
        LD A,(HL)
        LD (DE),A
        INC D
        INC HL
        LD A,(HL)
        LD (DE),A
        DEC D
        DEC D
        DEC D
        INC E
        RET 

PairZ   DB #00,#00,#22,#00
        DB #00,#0E,#2E,#0E
        DB #00,#E0,#E2,#E0
        DB #00,#EE,#EE,#EE

GETOPAR LD A,(XPOS)
        ADD A,high FRAMBUF
        LD H,A
        LD A,(YPOS)
        ADD A,A
        ADD A,A
        ADD A,A
        LD L,A
        LD A,(XSIZE)
        CP 5
        JR C,gopa_1
        LD A,5
gopa_1  LD B,A
        LD A,(YSIZE8)
        LD C,A
        CP 40
        JR C,gopa_2
        LD C,40
gopa_2  PUSH HL
        EXX 
        POP HL
        LD A,L
        RRA 
        RRA 
        RRA 
        AND 31
        OR #C0
        LD L,A
        EXX 
        RET 

CLR_ALL
        CALL CLREDIT
CLRVIEW LD HL,#4076
        LD BC,#2805
        CALL cedi_1
        LD HL,#5876
        LD BC,#0505
        JR cedi_A
CLREDIT LD HL,#4061
        LD BC,#A014
        CALL cedi_1
        LD HL,#5861
        LD BC,#1414
cedi_A  LD A,32
        SUB C
        LD E,A
        LD D,0
cedi_B  PUSH BC
cedi_C  LD (HL),7
        INC L
        DEC C
        JR NZ,cedi_C
        POP BC
        ADD HL,DE
        DJNZ cedi_B
        RET 
cedi_1  PUSH BC
        LD A,L
cedi_2  LD (HL),0
        INC L
        DEC C
        JR NZ,cedi_2
        LD L,A
        CALL NEXT_HL
        POP BC
        DJNZ cedi_1
        RET 

;------------------------

buttonz INCBIN "ani-butz.bin"
DEHRUST INCBIN "DEHRUST.bin"

Butz_22 DB 1,0,2,2,25
        DW MENFILE
        DB 3,0,2,2,26
        DW MENTRSH
        DB 5,0,2,2,28
        DW OVERLAY
        DB 7,0,2,2,27
        DW MENFRAM
        DB 9,0,2,2,30
        DW LIST

        DB 22,9,2,2,16
        DW SET_XOR
        DB 22,11,2,2,17
        DW SET_OR
        DB 22,13,2,2,18
        DW SET_AND

        DB 24,19,2,2,6
        DW MOV_UP
        DB 24,21,2,2,7
        DW MOV_DWN
        DB 22,20,2,2,8
        DW MOV_LEF
        DB 26,20,2,2,9
        DW MOV_RIG
        DB 29,19,2,2,10
        DW FLIP_V
        DB 29,21,2,2,11
        DW FLIP_H

        DB 31,12,1,1,31
        DW NXTFRAM
        DB 30,12,1,1,32
        DW PRVFRAM
        DB 31,10,1,1,31
        DW NXTPOS
        DB 30,10,1,1,32
        DW PRVPOS
        DB 31,14,1,1,31
        DW INCDLAY
        DB 30,14,1,1,32
        DW DECDLAY

        DB 1,3,20,20,255
        DW EDIT
        DB 22,3,5,5,255
        DW VIEWANI
        DB 24,9,2,2,34
        DW SEL_COL
SModBut DB 24,11,2,2,29
        DW SETMODE

        DB 0,3,1,20,255
        DW SBAR_V
        DB 1,23,20,1,255
        DW SBAR_H

        DB 255

MainKey
        DB 0
        DW #01F7,SET_XOR
        DW #02F7,SET_OR
        DW #04F7,SET_AND
        DW #10DF,SAVEBIN
        DW #08DF,UNDO
        DW #08FE,SEL_COL
        DW #10FE,VIEWANI
        DW #10FB,CHA_SHB
        DW #02FB,CHA_CHC
        DW #04FE,PUT_ZMB
        DB 1
        DW #10F7,EDIT_L
        DW #04EF,EDIT_R
        DW #08EF,EDIT_U
        DW #10EF,EDIT_D
        DW #04F7,GO_PRV
        DW #08F7,GO_NXT
        DW #08FE,COPY_F
        DB 2
        DW #01F7,0
        DB 255

ButtAdr DW 0
KeyAddr DW 0

        INCLUDE "anie03b.asm"
        INCLUDE "anie03d.asm"
        INCLUDE "arrow.asm"

XNEW    DB 1            ; новые размеры кадра
YNEW    DB 1
XSTEP   DW 1            ; для скролл-палок
YSTEP   DW 1

BX_TAB  DS 33
BY_TAB  DS 25

EdiType DB 0            ; XOR,OR,AND
EdiMode DB 0            ; FRAMES,LIST

YWin    DB 0
XWin    DB 0

FonAddr DW FREE_R
WinFone DW FREE_R

        DISPLAY "end @ ",/H,$,":#9B00"

;------------------------

REZID_0
        DISP #C000

SFON_RE JP sfon_R
RFON_RE JP rfon_R

sfon_R  LD HL,(FonAddr)
        LD A,(WinFone)
        LD (OldF_L+1),A
        LD A,(WinFone+1)
        LD (OldF_H+1),A
        LD (WinFone),HL
        LD (HL),E
        INC HL
        LD (HL),D
        INC HL
        LD (HL),C
        INC HL
        LD A,B
        ADD A,A
        ADD A,A
        ADD A,A
        LD (HL),A
        LD B,A
        INC HL
XWinOld LD (HL),0
        INC HL
YWinOld LD (HL),0
        INC HL
OldF_L  LD (HL),0
        INC HL
OldF_H  LD (HL),0
        INC HL
        EX DE,HL
sfo_1   PUSH BC
        PUSH HL
sfo_2   LD A,(HL)
        LD (DE),A
        INC L
        INC DE
        DEC C
        JR NZ,sfo_2
        POP HL
        POP BC
        CALL NEXT_HL
        LD A,H
        AND 7
        JR NZ,sfo_4
        PUSH HL
        PUSH DE
        LD A,C
        EXX 
        LD B,A
        POP DE
        POP HL
        LD A,H
        CALL TO_ATR
        LD H,A
        LD A,L
        SUB 32
        LD L,A
        SBC A,A
        ADD A,H
        LD H,A
sfo_3   LD A,(HL)
        LD (DE),A
        INC L
        INC DE
        DJNZ sfo_3
        PUSH DE
        EXX 
        POP DE
sfo_4   DJNZ sfo_1
        LD (FonAddr),DE
        RET 

rfon_R  LD HL,(WinFone)
        LD (FonAddr),HL
        LD E,(HL)
        INC HL
        LD D,(HL)
        INC HL
        LD C,(HL)
        INC HL
        LD B,(HL)
        INC HL
        LDB (XWin),(HL)
        INC HL
        LDB (YWin),(HL)
        INC HL
        LDB (WinFone),(HL)
        INC HL
        LDB (WinFone+1),(HL)
        INC HL
        CALL SET_WPA
        EX DE,HL
rfo_1   PUSH BC
        PUSH HL
rfo_2   LD A,(DE)
        LD (HL),A
        INC L
        INC DE
        DEC C
        JR NZ,rfo_2
        POP HL
        POP BC
        CALL NEXT_HL
        LD A,H
        AND 7
        JR NZ,rfo_4
        PUSH HL
        PUSH DE
        LD A,C
        EXX 
        LD B,A
        POP DE
        POP HL
        LD A,H
        CALL TO_ATR
        LD H,A
        LD A,L
        SUB 32
        LD L,A
        SBC A,A
        ADD A,H
        LD H,A
rfo_3   LD A,(DE)
        LD (HL),A
        INC L
        INC DE
        DJNZ rfo_3
        PUSH DE
        EXX 
        POP DE
rfo_4   DJNZ rfo_1
        RET 

WIND_RE PUSH AF
        LD A,(XWin)
        LD (XWinOld+1),A
        LD A,(YWin)
        LD (YWinOld+1),A
        LD A,D
        AND E
        INC A
        CALL Z,WIN_ARR
        LD (YWin),DE
        CALL SET_WPA
        LD A,E
        RRCA 
        RRCA 
        RRCA 
        AND #E0
        OR D
        LD L,A
        LD A,E
        AND #18
        OR #40
        LD D,A
        LD E,L
        PUSH DE
        PUSH BC
        CALL SFON_RE
        POP BC
        POP HL
        POP AF
        RET C
        DEC C
        DEC C
        PUSH BC
        PUSH HL
        CALL LINE_00
        CALL LINE_FF
        LD A,B
        ADD A,A
        ADD A,A
        ADD A,A
        SUB 4
        LD B,A
wind_Z  CALL LINE_CN
        DJNZ wind_Z
        CALL LINE_FF
        CALL LINE_00
        POP HL
        LD A,H
        CALL TO_ATR
        LD H,A
        POP BC
wind_X  CALL LINE_AT
        DJNZ wind_X
        RET 

LINE_AT LD DE,#0F0F
        LD A,E
        CALL LINE
        LD DE,32
        ADD HL,DE
        RET 

LINE_CN XOR A
        LD DE,#6006
        JR line
LINE_FF LD A,#FF
        LD DE,#7FFE
        JR line
LINE_00 XOR A
        LD D,A
        LD E,A
line    CALL LINE
        JP NEXT_HL

LINE    PUSH HL
        LD (HL),D
        INC L
        LD D,C
lin_Z   LD (HL),A
        INC L
        DEC D
        JR NZ,lin_Z
        LD (HL),E
        POP HL
        RET 

FREE_R  EQU $

        ENT 

R0_LEN  EQU $-REZID_0

rzd_osk LD HL,skin
        LD DE,FRAMBUF
        CALL DEHRUST
        LD HL,#5800
        LD DE,#5801
        LD BC,767
        LD (HL),L
        LDIR 
        LD HL,FRAMBUF
        LD DE,#4000
        LD BC,#1800
        LDIR 
        HALT 
        LD BC,#300
        LDIR 
        LDB (OUTSKIN),#C9
        RET 

START1  ei
	LD (stack+1),SP
        LD HL,stack
        LD (go_anie+1),HL
        CALL WRKBANK
        LD HL,REZID_0
        LD DE,#C000
        LD BC,R0_LEN
        LDIR 
        CALL CASHARR
        CALL CLS
        CALL OUTSKIN
        JP stack

skin    INCBIN "skin-2.pak"

;------------------------

        DISPLAY "code    #6000,",$-#6000

        SAVESNA "anie03.sna",go_anie